/*
********************************************************************************
* COPYRIGHT(c)    ϻ, 2016
* 
*        (as is).
*     .
********************************************************************************
*/




#ifndef __TM10P_BOARD_H
#define __TM10P_BOARD_H

#include "stm32f030x6.h"
#include "arm_math.h"


#define       ROWS_GPIO                    GPIOA
#define       ROW1_PIN                     7
#define       ROW2_PIN                     6
#define       ROW3_PIN                     5
#define       ROW4_PIN                     4
#define       ROW5_PIN                     3
#define       ROW6_PIN                     2
#define       ROW7_PIN                     1
#define       ROWS_MASK                    ((1 << ROW1_PIN) | (1 << ROW2_PIN) | (1 << ROW3_PIN) | (1 << ROW4_PIN) | (1 << ROW5_PIN) | (1 << ROW6_PIN) | (1 << ROW7_PIN))

#define       COL1_PIN                     13
#define       COL1_GPIO                    GPIOA
#define       COL2_PIN                     14
#define       COL2_GPIO                    GPIOA
#define       COL3_PIN                     0
#define       COL3_GPIO                    GPIOF
#define       COL4_PIN                     1
#define       COL4_GPIO                    GPIOF
#define       COL5_PIN                     1
#define       COL5_GPIO                    GPIOB


//
#define       ADC_GPIO                     GPIOA
#define       ADC_PIN                      0
#define       ADC_USED                     ADC1
#define       ADC_ENR                      APB2ENR
#define       ADC_CLK_EN                   RCC_APB2ENR_ADCEN
#define       ADC_IRQ                      ADC1_IRQn

// (DMA)
#define       DMA_FOR_ADC                  DMA1
#define       DMA_FOR_ADC_ENR              AHBENR
#define       DMA_FOR_ADC_CLK_EN           RCC_AHBENR_DMAEN
#define       DMA_CNL_FOR_ADC              DMA1_Channel1
#define       DMA_CNL_FOR_ADC_IRQ          DMA1_Channel1_IRQn

//   
#define       TIME_BASE_TIMER              TIM14
#define       TIME_BASE_TIMER_ENR          APB1ENR
#define       TIME_BASE_TIMER_CLK_EN       RCC_APB1ENR_TIM14EN
#define       TIME_BASE_TIMER_IRQ          TIM14_IRQn

//   
#define       ADC_TIMER                    TIM3
#define       ADC_TIMER_ENR                APB1ENR
#define       ADC_TIMER_CLK_EN             RCC_APB1ENR_TIM3EN
#define       ADC_TIMER_IRQ                TIM3_IRQn

#define       COLS_NUM                     5
#define       ROWS_NUM                     7

//
#define       END_OF_INDICATION            0x001F
#define       SINGLE_LED_MODE              (1 << 5)
#define       ADC_BUFFER_FULL              (1 << 0)

#define       NUM_OF_ADC_VALUES            128


#define       THRESHOLD_COEF               450

//   
// = (  /   ) * 
#define       COL_1_FREQ                   2 //(40000 / 128) * 2 = 625 ()
#define       COL_2_FREQ                   6 // 1875 ()
#define       COL_3_FREQ                   10 // 3125 ()
#define       COL_4_FREQ                   16 // 5000 ()
#define       COL_5_FREQ                   24 // 7500 ()


#define       BAND_1_LAST_BIN              3
#define       BAND_2_LAST_BIN              5
#define       BAND_3_LAST_BIN              10
#define       BAND_4_LAST_BIN              20
#define       BAND_5_LAST_BIN              63

#define       BAND_1_FIRST_BIN             2
#define       BAND_2_FIRST_BIN             (BAND_1_LAST_BIN + 1)
#define       BAND_3_FIRST_BIN             (BAND_2_LAST_BIN + 1)
#define       BAND_4_FIRST_BIN             (BAND_3_LAST_BIN + 1)
#define       BAND_5_FIRST_BIN             (BAND_4_LAST_BIN + 1)



extern const float32_t WindowCoef[128];


void TM10P_Init(void);

void TIME_BASE_TIMER_ISR(void);

void ADC_ISR(void);

void DMA_FOR_ADC_ISR(void);



#endif //__TM10P_BOARD_H